//se face afisarea in format mare prin folosirea de patternuri
#include <inttypes.h>
#include <avr/pgmspace.h>

#include "lcdb.h"
#include "lcd.h"

#define ORGFOUR

//se defineste cate o constanta pentru fiecare patern care compune o cifra in format mare
//am luat patternurile de pe www.mikrocontroller.net
const uint8_t CGRamImg[] PROGMEM = {
	0,0,0,0,1,3,7,15,
	0,0,0,0,31,31,31,31,
	0,0,0,0,16,24,28,30,
	31,31,31,31,30,28,24,16,
	16,24,28,30,31,31,31,31,
	15,7,3,1,0,0,0,0,
	31,31,31,31,0,0,0,0,
	30,28,24,16,0,0,0,0
};

const uint8_t Big0[] PROGMEM = {
    0,1,2,
    255,32,255,
    255,32,255,
    5,6,7
  };
  
const uint8_t Big1[] PROGMEM = {
    0,1,32,
    32,255,32,
    32,255,32,
    6,6,6
	};

const uint8_t Big2[] PROGMEM = {
    0,1,2,
    0,1,3,
    255,32,32,
    6,6,6
	};

const uint8_t Big3[] PROGMEM = {
    0,1,2,
    32,0,3,
    32,5,4,
    5,6,7
	};

const uint8_t Big4[] PROGMEM = {
#ifndef ORGFOUR
    0,32,1,
	255,32,255,
	6,6,255,
	32,32,6
#else
    1,32,32,
    255,1,255,
    32,32,255,
    32,32,6
#endif
	};
 
const uint8_t Big5[] PROGMEM = {
    1,1,1,
    255,1,2,
    32,32,255,
    6,6,7
	};

const uint8_t Big6[] PROGMEM = {
    0,1,2,
    255,1,2,
    255,32,255,
    5,6,7
	};

const uint8_t Big7[] PROGMEM = {
    1,1,1,
    32,0,3,
    32,255,32,
    32,6,32
	};
  
const uint8_t Big8[] PROGMEM = {
    0,1,2,
    255,1,255,
    255,32,255,
    5,6,7,
	};

const uint8_t Big9[] PROGMEM = {
    0,1,2,
    255,1,255,
    32,32,255,
    5,6,7
	};

const uint8_t *BigNums[] PROGMEM = {
	Big0, Big1, Big2, Big3, Big4, Big5, 
	Big6, Big7, Big8, Big9
};

//functia care copiaza paternurile  caracterelor definite mai sus din memoria 
//microcontroler-ului in ram-ul lcd-ului (CGRAM)
void LCDBigInit(void)
{
	uint8_t i;

	// setez pointerului de adresa ram al lcd-ului 0 */
	lcd_command( (1<<LCD_CGRAM)+0 ); 
	
	// fac copierea din ram pe display
	// dupa afisare se incrementeaza pointerul
	for (i = 0; i < sizeof(CGRamImg); i++) 
		lcd_putc( pgm_read_byte(&CGRamImg[i]) );
}

//functia care scrie un caracter in format mare
//argumentul num reprezinta cifra de la 0-9 pe care o afisez
//argumentul col reprezinta coloana lcd-ului
void LCDBigNumWrite(uint8_t num, uint8_t col)
{
	uint8_t c,r,i;
	uint8_t *pChar;
	
	/* get pointer to Big(num)-array in flash */
	pChar=(uint8_t*)(pgm_read_word(&BigNums[num]));
	
	i=0;
	for (r=0;r<4;r++) //bucla pe linii
	{
		lcd_gotoxy(col,r); // setez linia
		for (c=0;c<3;c++) //bucla pe coloane
		{
			//setez caracterul la pozitia (col+c,r) corespunzator paternului din BigX[i] unde X=cifra respectiva
			lcd_putc(pgm_read_byte(pChar+i));
			i++;
		}
	}
}
